//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3D4041CA013C.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3D4041CA013C.cm

//## begin module%3D4041CA013C.cp preserve=no
//## end module%3D4041CA013C.cp

//## Module: ScaleParam%3D4041CA013C; Package body
//## Subsystem: XSModel::Parameter%367691A8CEA0
//	/local/data/verisB/dorman/Xspec/src/XSModel/Parameter
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Parameter/ScaleParam.cxx

//## begin module%3D4041CA013C.additionalIncludes preserve=no
//## end module%3D4041CA013C.additionalIncludes

//## begin module%3D4041CA013C.includes preserve=yes
//## end module%3D4041CA013C.includes

// ScaleParam
#include <XSModel/Parameter/ScaleParam.h>
//## begin module%3D4041CA013C.declarations preserve=no
//## end module%3D4041CA013C.declarations

//## begin module%3D4041CA013C.additionalDeclarations preserve=yes
#include <XSModel/Model/Component/ComponentBase.h>
#include <XSModel/Parameter/ParameterLink.h>
#include <XSUtil/Error/Error.h>
#include <sstream>
#include <iomanip>
#include <cmath>
#include <limits>
//## end module%3D4041CA013C.additionalDeclarations


// Class ScaleParam 

ScaleParam::ScaleParam(const ScaleParam &right)
  //## begin ScaleParam::ScaleParam%38EB53E76DF0_copy.hasinit preserve=yes
      : Parameter(right),m_factor(right.m_factor)
  //## end ScaleParam::ScaleParam%38EB53E76DF0_copy.hasinit
  //## begin ScaleParam::ScaleParam%38EB53E76DF0_copy.initialization preserve=yes
  //## end ScaleParam::ScaleParam%38EB53E76DF0_copy.initialization
{
  //## begin ScaleParam::ScaleParam%38EB53E76DF0_copy.body preserve=yes
  //## end ScaleParam::ScaleParam%38EB53E76DF0_copy.body
}

ScaleParam::ScaleParam (const string& initString, ComponentBase* p)
  //## begin ScaleParam::ScaleParam%3A92A28600FD.hasinit preserve=yes
      : Parameter(p),m_factor(0.)
  //## end ScaleParam::ScaleParam%3A92A28600FD.hasinit
  //## begin ScaleParam::ScaleParam%3A92A28600FD.initialization preserve=yes
  //## end ScaleParam::ScaleParam%3A92A28600FD.initialization
{
  //## begin ScaleParam::ScaleParam%3A92A28600FD.body preserve=yes
  init(initString);
  //## end ScaleParam::ScaleParam%3A92A28600FD.body
}

ScaleParam::ScaleParam (const string& inputName, Real initial, ComponentBase* p)
  //## begin ScaleParam::ScaleParam%3D6A38EE0337.hasinit preserve=yes
      : Parameter(p), m_factor(initial)
  //## end ScaleParam::ScaleParam%3D6A38EE0337.hasinit
  //## begin ScaleParam::ScaleParam%3D6A38EE0337.initialization preserve=yes
  //## end ScaleParam::ScaleParam%3D6A38EE0337.initialization
{
  //## begin ScaleParam::ScaleParam%3D6A38EE0337.body preserve=yes
  name(inputName);
  //## end ScaleParam::ScaleParam%3D6A38EE0337.body
}


ScaleParam::~ScaleParam()
{
  //## begin ScaleParam::~ScaleParam%38EB53E76DF0_dest.body preserve=yes
  //## end ScaleParam::~ScaleParam%38EB53E76DF0_dest.body
}



//## Other Operations (implementation)
ScaleParam* ScaleParam::clone (ComponentBase* p) const
{
  //## begin ScaleParam::clone%38EB5764F328.body preserve=yes
  ScaleParam* cloned = new ScaleParam(*this);
  cloned->parent(p);
  return cloned;  
  //## end ScaleParam::clone%38EB5764F328.body
}

std::ostream& ScaleParam::put (std::ostream& s) const
{
  //## begin ScaleParam::put%38EB66F57CF8.body preserve=yes
  using namespace std;
  ios_base::fmtflags saveFlags(s.flags());
  streamsize savePrec(s.precision());
  const ComponentBase* component = parent();
  s  << setw(4) << index()   
     << setw(5) << component->index() << "   "
     << setw(11) << left << component->name() 
     << setw(11) << left << name()
     << setw(9) << left << "(scale)"; 
  Real absVal = fabs(value());
  if (absVal > 0)
  {
     int exp = static_cast<int>(floor(log10(absVal)));
     if (exp >= -1 && exp <= 3)
     {
        // Want 6 significant digits, prec gives number
        // of digits after decimal.
        int prec = 5 - exp;
        s << fixed << showpoint << setprecision(prec);
     }
     else
     {
        s << scientific << uppercase << setprecision(5);
     } 
  }
  else
  {
     // Just print 0.0
     s << fixed << showpoint << setprecision(1);
  }  
  s << left << setw(13) << value();
  
  if (isLinked())
  {
        thisLink()->putLink(s);  
  } 
  s.precision(savePrec);
  s.flags(saveFlags);
  
  //## end ScaleParam::put%38EB66F57CF8.body

  return s;
}

bool ScaleParam::compare (const Parameter& right) const
{
  //## begin ScaleParam::compare%38EB887C51C8.body preserve=yes
  if (!Parameter::compare(right)) return false; 
  const ScaleParam& that = static_cast<const ScaleParam&>(right);
  if (m_factor != that.m_factor) return false;
  return true;
  //## end ScaleParam::compare%38EB887C51C8.body
}

void ScaleParam::init (const string& initString)
{
  //## begin ScaleParam::init%38ECDA677D98.body preserve=yes
  if (initString.length())
  {
     std::istringstream s(initString);
     string parname;
     string unitLabel;
     Real factor=0.0;
     s >> parname;
     name(parname.substr(1,parname.length()-1));
     s >> unitLabel;
     if (unitLabel.length() == 1 && unitLabel[0] == '"')
     {
        // If simply a single ", this should be first of a
        // pair of " " enclosing a space, indicating no
        // unit label.
        s >> unitLabel;
        unitLabel.erase();
     }
     s >> factor;
     if (!s)
     {
        string errMsg("Syntax error for scale parameter ");
        errMsg += name() + " in model description file.\n";
        throw YellowAlert(errMsg);
     }
     setValue(factor);
  }
  //## end ScaleParam::init%38ECDA677D98.body
}

void ScaleParam::changeValue (const string& parString)
{
  //## begin ScaleParam::changeValue%38F64295DA98.body preserve=yes
  using std::ios_base;
  
  // remove the link if any and reset the parameter to its file values
  // without preserving current setting
  untie(false); 
        
  int begin = parString.find_first_not_of(" \t");
  std::istringstream s(parString.substr(begin));
  s.exceptions(ios_base::badbit | ios_base::failbit | ios_base::eofbit );
  string errMsg = "Parameter "+ name() + ": floating point value required ";
  Real currentValue = value();
  Real newValue;
  try 
  {               
        s >> newValue;
  }
  catch  ( ios_base::failure & )
  {        
            if (s.eof() )  
            {
                // do nothing. continue
            }
            else  if (s.fail())
            {
                            throw Parameter::InvalidInput(errMsg);
            }    
            else 
            {
                    if (s.bad()) 
                    {
                            throw RedAlert(" reading parameter values\n");
                    }
            }
  }  
  
  if ( std::abs(currentValue - newValue) > std::numeric_limits<float>::min() ) 
  {
        setValue(newValue);   
  }    
  else changed(false);
  //## end ScaleParam::changeValue%38F64295DA98.body
}

Real ScaleParam::value () const
{
  //## begin ScaleParam::value%3900949D7DA8.body preserve=yes
  if (!isLinked()) return m_factor;
  else return thisLink()->linkValue();
  //## end ScaleParam::value%3900949D7DA8.body
}

void ScaleParam::setValue (Real& val)
{
  //## begin ScaleParam::setValue%3900953E5F50.body preserve=yes
  m_factor = val;
  changed(true);
  setCompute(true);
  setComputeForLinks(true);
  //## end ScaleParam::setValue%3900953E5F50.body
}

void ScaleParam::doPreserve ()
{
  //## begin ScaleParam::doPreserve%3C0FD48B0341.body preserve=yes
  if (isLinked())
  {
        Real currentValue (thisLink()->linkValue());
        links()->unlink(this);
        reset();
        m_factor = currentValue;       
  }  
  //## end ScaleParam::doPreserve%3C0FD48B0341.body
}

string ScaleParam::stringVal () const
{
  //## begin ScaleParam::stringVal%3CEC009F01F1.body preserve=yes
  std::ostringstream val("");
  val << m_factor << " " << name();
  return val.str();
  //## end ScaleParam::stringVal%3CEC009F01F1.body
}

string ScaleParam::parameterSetting () const
{
  //## begin ScaleParam::parameterSetting%3F2E79C50232.body preserve=yes
  std::ostringstream val;

  val.precision(6);
  if (!isLinked())
  {
        val  << std::setw(15) << m_factor;
  }
  else
  {
        val << "= " << thisLink()->linkExpression(false);
  }
  return val.str();  
  //## end ScaleParam::parameterSetting%3F2E79C50232.body
}

// Additional Declarations
  //## begin ScaleParam%38EB53E76DF0.declarations preserve=yes
  //## end ScaleParam%38EB53E76DF0.declarations

//## begin module%3D4041CA013C.epilog preserve=yes
//## end module%3D4041CA013C.epilog
